#include <iostream>
#define MNOGO 4000000
using namespace std;
int a[101][101];
int used[101];
int prev[101];
int price[101];
int dist[101];
int n, m, t1, t2, s1, s2;

int choose()
 {
  int minindex=1, mindata=MNOGO;
  for(int i=1; i<=n; i++)
   if(!used[i] && dist[i]<mindata) { mindata=dist[i]; minindex=i; }
  used[minindex]=true;
  return minindex;
 }

void dijkstra(int s)
 {
  for(int i=1; i<=n ; i++) dist[i]=MNOGO;
  dist[s]=0;
  prev[s]=0;
  int q;
  for(int i=1; i<=n; i++)
   {
    q=choose();
    for(int i=1; i<=n; i++) if(a[q][i] && !used[i]) if(dist[q]+a[q][i]<dist[i]) { dist[i]=dist[q]+a[q][i]; prev[i]=q; }
   }
 }

int main()
 {
  cin>>n;
  for(int i=1; i<=n; i++) { cin>>price[i]; }
  cin>>m;
  for(int i=1; i<=m; i++) { cin>>t1>>t2; a[t1][t2]=price[t1]; a[t2][t1]=price[t2]; }
  dijkstra(1);
  if(dist[n]==MNOGO) { cout<<-1<<endl; return 0; }
  cout<<dist[n]<<endl;
  return 0;
 }
  
